<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::shared_ptr&lt; T &gt;::deleter_template&lt; D &gt; Struct Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a></li><li class="navelem"><a class="el" href="structdlib_1_1shared__ptr_1_1deleter__template.html">deleter_template</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="structdlib_1_1shared__ptr_1_1deleter__template-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::shared_ptr&lt; T &gt;::deleter_template&lt; D &gt; Struct Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::shared_ptr&lt; T &gt;::deleter_template&lt; D &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structdlib_1_1shared__ptr_1_1deleter__template.png" usemap="#dlib::shared_5Fptr_3C_20T_20_3E::deleter_5Ftemplate_3C_20D_20_3E_map" alt=""/>
  <map id="dlib::shared_5Fptr_3C_20T_20_3E::deleter_5Ftemplate_3C_20D_20_3E_map" name="dlib::shared_5Fptr_3C_20T_20_3E::deleter_5Ftemplate_3C_20D_20_3E_map">
<area href="structdlib_1_1shared__ptr__deleter.html" alt="dlib::shared_ptr_deleter" shape="rect" coords="0,0,261,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:acfb9ed60391489bee27b37e2b3ee8511"><td class="memItemLeft" align="right" valign="top"><a id="acfb9ed60391489bee27b37e2b3ee8511"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>deleter_template</b> (const D &amp;d_)</td></tr>
<tr class="separator:acfb9ed60391489bee27b37e2b3ee8511"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7a15f53ffd3f15d6b2ae0ca41d6c338"><td class="memItemLeft" align="right" valign="top"><a id="aa7a15f53ffd3f15d6b2ae0ca41d6c338"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>del</b> (const void *p)</td></tr>
<tr class="separator:aa7a15f53ffd3f15d6b2ae0ca41d6c338"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1925c475502a1cd05d382072d7a65ee"><td class="memItemLeft" align="right" valign="top"><a id="ab1925c475502a1cd05d382072d7a65ee"></a>
void *&#160;</td><td class="memItemRight" valign="bottom"><b>get_deleter_void</b> (const std::type_info &amp;t) const</td></tr>
<tr class="separator:ab1925c475502a1cd05d382072d7a65ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:ae716e2c213d634681fc5b5f1cda044c8"><td class="memItemLeft" align="right" valign="top"><a id="ae716e2c213d634681fc5b5f1cda044c8"></a>
D&#160;</td><td class="memItemRight" valign="bottom"><b>d</b></td></tr>
<tr class="separator:ae716e2c213d634681fc5b5f1cda044c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
template&lt;typename D&gt;<br />
struct dlib::shared_ptr&lt; T &gt;::deleter_template&lt; D &gt;</h3>

<pre class="fragment">CONVENTION
    - get() == data
    - unique() == (shared_node != 0) &amp;&amp; (shared_node-&gt;ref_count == 1)
    - if (shared_node != 0) then
        - use_count() == shared_node-&gt;ref_count
        - get() == a valid pointer
        - if (we are supposed to use the deleter) then
            - shared_node-&gt;del == the deleter to use
        - else
            - shared_node-&gt;del == 0
    - else
        - use_count() == 0
        - get() == 0


    - if (there are any weak_ptrs that reference this-&gt;data) then
        - shared_node-&gt;weak_node-&gt;ref_count == the number of referencing weak_ptrs
    - else
        - shared_node-&gt;weak_node == 0
</pre><p> ! </p>
</div><hr/>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="shared__ptr_8h_source.html">shared_ptr.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
